redArrow = LibStub("AceAddon-3.0"):NewAddon("Red Arrow", "AceConsole-3.0", "AceEvent-3.0")
local L = LibStub("AceLocale-3.0"):GetLocale("Red Arrow")
local mod = redArrow

local options = {
	type = "group",
	name = "Red arrow",
	args = {
		status = {
			type = "toggle",
			order = 1,
			name = L["Show or hide"],
			width = "full",
			get = function()
				return mod.db.profile.status
			end,
			set = function(info, v)
				mod.db.profile.status = v
				if v == true then
				  redarrowFrame:Show()
				else
				  redarrowFrame:Hide()
				end
			end,
			disabled = false,
		},
		radius = {
			type = "range",
			name = L["Radius"],
			order = 4,
			min = 20,
			max = 200,
			step = 1,
			bigStep = 4,
			get = function() return mod.db.profile.radius end,
			set = function(info, v) mod.db.profile.radius = v mod:UpdateLayout() end,
			disabled = false,
		},
		size = {
			type = "range",
			name = L["Size"],
			order = 4,
			min = 5,
			max = 62,
			step = 1,
			bigStep = 4,
			get = function() return mod.db.profile.size end,
			set = function(info, v) mod.db.profile.size = v mod:UpdateLayout() end,
			disabled = false,
		}
	}
}

local defaults = {
    profile =  {
		status = true,
		radius=33,
		size=44
    },
}

function redArrow:OnInitialize()
    -- Called when the addon is loaded
    mod.db = LibStub("AceDB-3.0"):New("redArrowDB", defaults, true)
    LibStub("AceConfig-3.0"):RegisterOptionsTable("Red Arrow", options)
    self.optionsFrame = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("Red Arrow", "Red Arrow")
    self:RegisterChatCommand("rh", "ChatCommand")
    self:RegisterChatCommand("redarrow", "ChatCommand")
end


function redArrow:ChatCommand(input)
--    if not input or input:trim() == "" then
        InterfaceOptionsFrame_OpenToCategory(self.optionsFrame)
--    else
--        LibStub("AceConfigCmd-3.0"):HandleCommand("wh", "WelcomeHome", input)
--    end
end

function redArrow:OnEnable()
print("onenable Started")	

	redarrowFrame = CreateFrame("Frame", "SexyMapRedarrowFrame", Minimap)
	redarrowFrame:SetSize(32,32)
	redarrowFrame:SetPoint("CENTER")
	redarrowFrame.arrow = redarrowFrame:CreateTexture("MyArrow","OVERLAY")
	redarrowFrame.arrow:SetAllPoints(true)
	redarrowFrame.arrow:SetTexture("Interface\\Minimap\\Minimap-DeadArrow")

	if mod.db.profile.status then
		redarrowFrame:Show()
		mod:UpdateLayout()
	end
end

local s2 = sqrt(2);
local cos, sin, rad = math.cos, math.sin, math.rad;
local function CalculateCorner(angle)
    local r = rad(angle);
    return 0.5 + cos(r) / s2, 0.5 + sin(r) / s2;
end

local function CalculateDelta(angle,radius)
    local r = rad(angle+90);
    return radius * cos(r) , radius *sin(r) ;
end

local function RotateTexture(angle)
	local deltax,deltay = CalculateDelta(angle,mod.db.profile.radius)
--	print ("delta",deltax,deltay)
	
    local LRx, LRy = CalculateCorner(angle + 45);
    local LLx, LLy = CalculateCorner(angle + 135);
    local ULx, ULy = CalculateCorner(angle + 225);
    local URx, URy = CalculateCorner(angle - 45);
--	print (LRx,LRy,LLx,LLy,ULx,ULy,URx,URy)
	redarrowFrame:SetPoint("CENTER", "Minimap", "CENTER", deltax, deltay);
    redarrowFrame.arrow:SetTexCoord(ULx, ULy, LLx, LLy, URx, URy, LRx, LRy);
end

function redArrow:UpdateLayout()
  redarrowFrame:SetSize(mod.db.profile.size,mod.db.profile.size)
  redarrowFrame.timer = 0
  redarrowFrame:SetScript("OnUpdate",function(self,elapsed)
    self.timer = self.timer + elapsed
    if self.timer > 0.1 then
	  local facing=GetPlayerFacing()
	  if facing == nil then
	    facing=0
	  end 
      RotateTexture(math.deg(facing))
    end
  end)
end
